;; If the numbers 1 to 5 are written out in words: one, two, three,
;; four, five; there are 3 + 3 + 5 + 4 + 4 = 19 letters used in total.
;;
;; If all the numbers from 1 to 1000 (one thousand) inclusive were
;; written out in words, how many letters would be used?  NOTE: Do not
;; count spaces or hyphens. 
;;
;; For example, 342 (three hundred and forty-two) contains 23 letters
;; and 115 (one hundred and fifteen) contains 20 letters.

;(require 'asdf-install)
;(asdf-install:install :cl-ppcre)
(require 'cl-ppcre)

(defun print-number (num)
  (cl-ppcre:regex-replace-all
   "-"
   (let ((str (format nil "~r" num)))
     (if (cl-ppcre:all-matches " hundred " str)
	 (cl-ppcre:regex-replace " hundred " str " hundred and ")
	 str))
   " "))

; (print-number 142)

(defun count-letters (num)
  (let ((count 0))
    (loop for ch across (print-number num)
	  do
	  (when (not (equalp #\Space ch))
	    (incf count)))
    count))

;(format nil "~r" 101)
;(count-letters 101)
; (format nil "~r" 342)


(assert (= 23 (count-letters 342)))
(assert (= 20 (count-letters 115)))

(time 
 (let ((total 0))
   (loop for ii from 1 to 1000
	 do
	 (setf total (+ total
			(count-letters ii))))
   (format t "total:~a~&" total)
   total))